## eckit 2.0.1

=== CMakeLists.txt ===
# (C) Copyright 2011- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

########################################################################################################################


cmake_minimum_required( VERSION 3.18 FATAL_ERROR )

find_package( ecbuild 3.7 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)

project( eckit LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

########################################################################################################################
### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Sandbox playground for prototyping code that may never see the light of day" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()

### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_BUILDERS_DEBUG
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory builders debug"
                    ADVANCED )

ecbuild_add_option( FEATURE ECKIT_MEMORY_FACTORY_EMPTY_DESTRUCTION
                    DEFAULT OFF
                    DESCRIPTION "eckit::Factory empty destruction (system dependant)"
                    ADVANCED )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_find_lexyacc()

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    CONDITION LEXYACC_FOUND
                    REQUIRED_PACKAGES "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    CONDITION LEXYACC_FOUND )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### OpenMP

ecbuild_add_option( FEATURE OMP
                    DEFAULT OFF
                    DESCRIPTION "OpenMP linear algebra backend"
                    REQUIRED_PACKAGES "OpenMP COMPONENTS CXX" )

if( NOT TARGET OpenMP::OpenMP_CXX )
    set( eckit_HAVE_OMP 0 )
endif()

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression options

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES "NAME libaec VERSION 1.1.4")

ecbuild_add_option( FEATURE ZIP
                    DESCRIPTION "ZIP support for compression"
                    REQUIRED_PACKAGES libzip )

### Hashing options

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "xxHash support for hashing" )

### eckit::codec

ecbuild_add_option( FEATURE ECKIT_CODEC
                    DEFAULT ON
                    DESCRIPTION "eckit::codec encoding/decoding library" )

set( eckit_CODEC_STATIC_ASSERT ON CACHE BOOL "eckit::codec static assertions" )

### eckit::spec

ecbuild_add_option( FEATURE ECKIT_SPEC
                    DEFAULT ON
                    DESCRIPTION "eckit::spec metadata library" )

### eckit::maths

ecbuild_add_option( FEATURE CONVEX_HULL
                    DEFAULT OFF
                    DESCRIPTION "eckit::maths library convex hull/Delaunay triangulation" )
                    # REQUIRED_PACKAGES "Qhull COMPONENTS C CXX"

if( eckit_HAVE_CONVEX_HULL )
    find_package( Qhull REQUIRED CONFIG )

    if( NOT TARGET Qhull::qhullcpp OR NOT TARGET Qhull::qhullstatic_r )
        message( FATAL_ERROR "eckit::maths ENABLE_CONVEX_HULL requires Qhull C/C++ libraries" )
    endif()

    add_library(Qhull::Qhull INTERFACE IMPORTED)
    target_link_libraries(Qhull::Qhull INTERFACE Qhull::qhullcpp Qhull::qhullstatic_r )
endif()

### eckit::geo

ecbuild_add_option( FEATURE ECKIT_GEO
                    DEFAULT ON
                    DESCRIPTION "eckit::geo geometry library" )

ecbuild_add_option( FEATURE GEO_CACHING
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default caching behaviour" )

ecbuild_add_option( FEATURE GEO_BITREPRODUCIBLE
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library bit reproducibility tests" )

ecbuild_add_option( FEATURE GEO_PROJECTION_PROJ_DEFAULT
                    DEFAULT OFF
                    CONDITION eckit_HAVE_ECKIT_GEO
                    DESCRIPTION "eckit::geo geometry library default to PROJ-based projections" )

ecbuild_add_option( FEATURE GEO_AREA_SHAPEFILE
                    DEFAULT ON
                    CONDITION eckit_HAVE_ECKIT_GEO AND eckit_HAVE_ZIP
                    REQUIRED_PACKAGES shapelib
                    DESCRIPTION "eckit::geo geometry library support for shapefiles" )

set( ECKIT_GEO_CODEC_GRIDS OFF )
if( eckit_HAVE_ECKIT_CODEC AND eckit_HAVE_LZ4 )
    set( ECKIT_GEO_CODEC_GRIDS ON )
endif()

if( eckit_HAVE_GEO_AREA_SHAPEFILE )
    if( NOT TARGET shapelib::shp OR NOT TARGET libzip::zip )
        message( FATAL_ERROR "eckit::geo geometry library support for shapefiles requires the shapelib::shp and libzip::zip libraries" )
    endif()
endif()

# (keep paths as strings to avoid normalisation/expansion)
set( eckit_GEO_CACHE_PATH "~/.local/share/eckit/geo" CACHE STRING "eckit::geo cache path default" )
set( eckit_GEO_SHARE_URL_PREFIX "https://sites.ecmwf.int/repository/eckit/geo" CACHE STRING "eckit::geo URL prefix for downloadable assets" )

### LAPACK

if( eckit_HAVE_MKL )
    set( eckit_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1 and MD4)

ecbuild_add_option( FEATURE SSL
                    DEFAULT OFF # We only use deprecated functionality from OpenSSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES "CURL 7.20" )

if(HAVE_CURL)
  ecbuild_info("Curl version ${CURL_VERSION_STRING} -- libs [${CURL_LIBRARIES}] incs [${CURL_INCLUDE_DIRS}]")
endif()

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    DEFAULT OFF
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDAToolkit )

#### HIP

ecbuild_add_option( FEATURE HIP
                    DEFAULT OFF
                    DESCRIPTION "HIP GPU linear algebra operations"
                    REQUIRED_PACKAGES hip hipsparse )

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### UNICODE support

check_include_file_cxx("codecvt" HAVE_CXX_CODECVT)

ecbuild_add_option( FEATURE UNICODE
                    DEFAULT ON
                    CONDITION HAVE_CXX_CODECVT
                    DESCRIPTION "Add support for Unicode characters in Yaml/JSON parsers" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### PROJ support

ecbuild_add_option( FEATURE PROJ
                    DEFAULT OFF
                    DESCRIPTION "support PROJ-based projections"
                    REQUIRED_PACKAGES "PROJ 9.1.1" )

ecbuild_add_option(
    FEATURE DOCS
    DEFAULT OFF
    DESCRIPTION "Enable documentation generation"
)

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
    set( RT_LIBRARIES "" )
endif()

### sanity checks

include(cmake/check_time_t_Y2038.cmake) # check Y2038 time_t compatibility

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# sources

include(cmake/compiler_warnings.cmake) # optionally handle compiler specific warnings

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

add_subdirectory( src )
if(eckit_HAVE_DOCS)
    add_subdirectory(docs)
endif()
add_subdirectory( share )

if( eckit_HAVE_TESTS )
    add_subdirectory( tests )
    add_subdirectory( regressions )
endif()

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files
                       SOURCES AUTHORS README.md NOTICE LICENSE
                       INSTALL ChangeLog COPYING )

############################################################################################
# finalize

set( ECKIT_LIBRARIES ${eckit_ALL_LIBS} ) # used for ecbuild_pkgconfig

foreach( _lib ${ECKIT_LIBRARIES} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( eckit_BIG_ENDIAN    1 )
        set( eckit_LITTLE_ENDIAN 0 )
else()
        set( eckit_BIG_ENDIAN    0 )
        set( eckit_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${eckit_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${eckit_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  eckit_HAVE_DLFCN_H )

if(NOT eckit_HAVE_DLFCN_H)
message(FATAL_ERROR "eckit requires dlfcn.h for supporting dlopen of shared libraries")
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        eckit_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS   "sys/mman.h"  eckit_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON        "sys/mman.h"  eckit_HAVE_MAP_ANON )
check_symbol_exists( funopen         "stdio.h"     eckit_HAVE_FUNOPEN )
check_symbol_exists( fsync           "unistd.h"    eckit_HAVE_FSYNC )
check_symbol_exists( fdatasync       "unistd.h"    eckit_HAVE_FDATASYNC )
check_symbol_exists( F_FULLFSYNC     "fcntl.h"     eckit_HAVE_F_FULLFSYNC )
check_symbol_exists( fmemopen        "stdio.h"     eckit_HAVE_FMEMOPEN )
check_symbol_exists( dlinfo          "dlfcn.h"     eckit_HAVE_DLINFO )
check_symbol_exists( feenableexcept  "fenv.h"      eckit_HAVE_FEENABLEEXCEPT )
check_symbol_exists( fedisableexcept "fenv.h"      eckit_HAVE_FEDISABLEEXCEPT )

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    eckit_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    eckit_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    eckit_HAVE_CXXABI_H )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    eckit_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    eckit_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    eckit_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    eckit_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    eckit_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
        ${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
    DESTINATION
        ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h deprecated.h ${CMAKE_CURRENT_BINARY_DIR}/eckit_version.cc )

list( APPEND eckit_container_srcs
    container/BSPTree.h
    container/BTree.cc
    container/BTree.h
    container/BloomFilter.cc
    container/BloomFilter.h
    container/Cache.h
    container/CacheLRU.cc
    container/CacheLRU.h
    container/CacheManager.cc
    container/CacheManager.h
    container/ClassExtent.h
    container/DenseMap.h
    container/DenseSet.h
    container/KDMapped.cc
    container/KDMapped.h
    container/KDMemory.h
    container/KDTree.h
    container/MappedArray.cc
    container/MappedArray.h
    container/Queue.h
    container/Recycler.h
    container/SharedMemArray.cc
    container/SharedMemArray.h
    container/StatCollector.h
    container/Trie.cc
    container/Trie.h
    container/bsptree/BSPHyperPlane.h
    container/bsptree/BSPNode.cc
    container/bsptree/BSPNode.h
    container/kdtree/KDNode.cc
    container/kdtree/KDNode.h
    container/sptree/SPIterator.h
    container/sptree/SPMetadata.h
    container/sptree/SPNode.h
    container/sptree/SPNodeInfo.h
    container/sptree/SPNodeQueue.h
    container/sptree/SPTree.h
    container/sptree/SPValue.h
)

list( APPEND eckit_io_srcs
    io/AIOHandle.cc
    io/AIOHandle.h
    io/AsyncHandle.cc
    io/AsyncHandle.h
    io/AutoCloser.h
    io/Base64.cc
    io/Base64.h
    io/BitIO.cc
    io/BitIO.h
    io/Buffer.cc
    io/Buffer.h
    io/BufferCache.cc
    io/BufferCache.h
    io/BufferList.cc
    io/BufferList.h
    io/BufferedHandle.cc
    io/BufferedHandle.h
    io/CircularBuffer.cc
    io/CircularBuffer.h
    io/CommandStream.cc
    io/CommandStream.h
    io/Compress.cc
    io/Compress.h
    io/DataHandle.cc
    io/DataHandle.h
    io/DblBuffer.cc
    io/DblBuffer.h
    io/EmptyHandle.cc
    io/EmptyHandle.h
    io/FDataSync.cc
    io/FDataSync.h
    io/FOpenDataHandle.cc
    io/FTPHandle.cc
    io/FTPHandle.h
    io/FileBase.cc
    io/FileBase.h
    io/FileDescHandle.cc
    io/FileDescHandle.h
    io/FileHandle.cc
    io/FileHandle.h
    io/FileLock.cc
    io/FileLock.h
    io/FileLocker.cc
    io/FileLocker.h
    io/FilePool.cc
    io/FilePool.h
    io/HandleBuf.cc
    io/HandleBuf.h
    io/HandleHolder.cc
    io/HandleHolder.h
    io/Length.cc
    io/Length.h
    io/MMappedFileHandle.cc
    io/MMappedFileHandle.h
    io/MemoryHandle.cc
    io/MemoryHandle.h
    io/MoverTransfer.cc
    io/MoverTransfer.h
    io/MoverTransferSelection.cc
    io/MoverTransferSelection.h
    io/MultiHandle.cc
    io/MultiHandle.h
    io/MultiSocketHandle.cc
    io/MultiSocketHandle.h
    io/Offset.cc
    io/Offset.h
    io/PartFileHandle.cc
    io/PartFileHandle.h
    io/PartHandle.cc
    io/PartHandle.h
    io/PeekHandle.cc
    io/PeekHandle.h
    io/PipeHandle.cc
    io/PipeHandle.h
    io/Pipeline.cc
    io/Pipeline.h
    io/PooledFile.cc
    io/PooledFile.h
    io/PooledFileDescriptor.cc
    io/PooledFileDescriptor.h
    io/PooledHandle.cc
    io/PooledHandle.h
    io/RawFileHandle.cc
    io/RawFileHandle.h
    io/ResizableBuffer.h
    io/SeekableHandle.cc
    io/SeekableHandle.h
    io/Select.cc
    io/Select.h
    io/SharedBuffer.cc
    io/SharedBuffer.h
    io/SharedHandle.cc
    io/SharedHandle.h
    io/SockBuf.cc
    io/SockBuf.h
    io/StatsHandle.cc
    io/StatsHandle.h
    io/StdFile.cc
    io/StdFile.h
    io/StdPipe.cc
    io/StdPipe.h
    io/StdioBuf.cc
    io/StdioBuf.h
    io/TCPHandle.cc
    io/TCPHandle.h
    io/TCPSocketHandle.cc
    io/TCPSocketHandle.h
    io/TeeHandle.cc
    io/TeeHandle.h
    io/TransferWatcher.cc
    io/TransferWatcher.h
    io/cluster/ClusterDisks.cc
    io/cluster/ClusterDisks.h
    io/cluster/ClusterNode.cc
    io/cluster/ClusterNode.h
    io/cluster/ClusterNodes.cc
    io/cluster/ClusterNodes.h
    io/cluster/NodeInfo.cc
    io/cluster/NodeInfo.h
)

if(HAVE_CURL)
    list(APPEND eckit_io_srcs
        io/EasyCURL.cc
        io/EasyCURL.h
        io/URLHandle.cc
        io/URLHandle.h
    )
endif()

list(APPEND eckit_message_srcs
    message/Decoder.cc
    message/Decoder.h
    message/Message.cc
    message/Message.h
    message/MessageContent.cc
    message/MessageContent.h
    message/Reader.cc
    message/Reader.h
    message/Splitter.cc
    message/Splitter.h
)

if(HAVE_RADOS)
    list( APPEND eckit_io_srcs
        io/rados/RadosHandle.cc
        io/rados/RadosHandle.h
        io/rados/RadosCluster.h
        io/rados/RadosCluster.cc
        io/rados/RadosReadHandle.cc
        io/rados/RadosReadHandle.h
        io/rados/RadosWriteHandle.cc
        io/rados/RadosWriteHandle.h
        io/rados/RadosObject.h
        io/rados/RadosObject.cc
        io/rados/RadosAttributes.h
        io/rados/RadosAttributes.cc
    )
endif()

list( APPEND eckit_filesystem_srcs
    filesystem/BasePathName.cc
    filesystem/BasePathName.h
    filesystem/BasePathNameT.cc
    filesystem/BasePathNameT.h
    filesystem/FileMode.cc
    filesystem/FileMode.h
    filesystem/FileSpace.cc
    filesystem/FileSpace.h
    filesystem/FileSpaceStrategies.cc
    filesystem/FileSpaceStrategies.h
    filesystem/FileSystem.cc
    filesystem/FileSystem.h
    filesystem/FileSystemSize.h
    filesystem/LocalPathName.cc
    filesystem/LocalPathName.h
    filesystem/PathExpander.cc
    filesystem/PathExpander.h
    filesystem/PathName.cc
    filesystem/PathName.h
    filesystem/PathNameFactory.cc
    filesystem/PathNameFactory.h
    filesystem/TempFile.cc
    filesystem/TempFile.h
    filesystem/TmpDir.cc
    filesystem/TmpDir.h
    filesystem/StdDir.cc
    filesystem/StdDir.h
    filesystem/TmpFile.cc
    filesystem/TmpFile.h
    filesystem/URI.cc
    filesystem/URI.h
    filesystem/URIManager.cc
    filesystem/URIManager.h
    filesystem/LocalFileManager.cc
    filesystem/LocalFileManager.h
)

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
    config/Configurable.cc
    config/Configurable.h
    config/Configuration.cc
    config/Configuration.h
    config/Configured.cc
    config/Configured.h
    config/EtcTable.cc
    config/EtcTable.h
    config/JSONConfiguration.h
    config/LibEcKit.cc
    config/LibEcKit.h
    config/LocalConfiguration.cc
    config/LocalConfiguration.h
    config/Parametrisation.cc
    config/Parametrisation.h
    config/Resource.h
    config/ResourceBase.cc
    config/ResourceBase.h
    config/ResourceMgr.cc
    config/ResourceMgr.h
    config/YAMLConfiguration.cc
    config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
    runtime/Application.cc
    runtime/Application.h
    runtime/Dispatcher.h
    runtime/Library.cc
    runtime/Library.h
    runtime/Main.cc
    runtime/Main.h
    runtime/Metrics.cc
    runtime/Metrics.h
    runtime/Monitor.cc
    runtime/Monitor.h
    runtime/Monitorable.cc
    runtime/Monitorable.h
    runtime/Pipe.h
    runtime/PipeApplication.cc
    runtime/PipeApplication.h
    runtime/PipeHandler.cc
    runtime/PipeHandler.h
    runtime/ProcessControler.cc
    runtime/ProcessControler.h
    runtime/ProducerConsumer.h
    runtime/Telemetry.cc
    runtime/Telemetry.h
    runtime/SessionID.cc
    runtime/SessionID.h
    runtime/Task.cc
    runtime/Task.h
    runtime/TaskID.h
    runtime/TaskInfo.cc
    runtime/TaskInfo.h
    runtime/Tool.cc
    runtime/Tool.h
)

list( APPEND eckit_log_srcs
    log/BigNum.cc
    log/BigNum.h
    log/Bytes.cc
    log/Bytes.h
    log/CallbackTarget.cc
    log/CallbackTarget.h
    log/Channel.cc
    log/Channel.h
    log/ChannelBuffer.cc
    log/ChannelBuffer.h
    log/CodeLocation.cc
    log/CodeLocation.h
    log/Colour.cc
    log/Colour.h
    log/ColouringTarget.cc
    log/ColouringTarget.h
    log/ETA.cc
    log/ETA.h
    log/FileTarget.cc
    log/FileTarget.h
    log/IndentTarget.cc
    log/IndentTarget.h
    log/JSON.cc
    log/JSON.h
    log/LineBasedTarget.cc
    log/LineBasedTarget.h
    log/Log.cc
    log/Log.h
    log/LogTarget.cc
    log/LogTarget.h
    log/MessageTarget.cc
    log/MessageTarget.h
    log/MonitorTarget.cc
    log/MonitorTarget.h
    log/Number.cc
    log/Number.h
    log/OStreamTarget.cc
    log/OStreamTarget.h
    log/Plural.h
    log/PrefixTarget.cc
    log/PrefixTarget.h
    log/Progress.cc
    log/Progress.h
    log/ProgressTimer.cc
    log/ProgressTimer.h
    log/ResourceUsage.cc

=== src/tools/CMakeLists.txt ===
ecbuild_add_executable( TARGET      eckit_version
                        OUTPUT_NAME eckit-version
                        SOURCES     eckit-version.cc
                        LIBS        eckit_option eckit )

if( NOT eckit_HAVE_BUILD_TOOLS )
    return()
endif()

ecbuild_add_executable( TARGET      eckit_info
                        OUTPUT_NAME eckit-info
                        SOURCES     eckit-info.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      eckit_fraction
                        OUTPUT_NAME eckit-fraction
                        SOURCES     eckit-fraction.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      eckit_codec_list
                        OUTPUT_NAME eckit-codec-list
                        CONDITION   eckit_HAVE_ECKIT_CODEC
                        SOURCES     eckit-codec-list.cc
                        LIBS        eckit_codec eckit_option )

foreach( _name
        eckit-area-list
        eckit-gaussian-latitudes
        eckit-grid
        eckit-grid-list
        eckit-grid-nearest
        eckit-grid-spec )
    string(REPLACE "-" "_" _target ${_name})
    ecbuild_add_executable( TARGET      ${_target}
                            OUTPUT_NAME ${_name}
                            SOURCES     ${_name}.cc
                            CONDITION   eckit_HAVE_ECKIT_GEO
                            LIBS        eckit_geo eckit_option )
endforeach()


### NOT TO INSTALL

ecbuild_add_executable( TARGET      dhcopy
                        OUTPUT_NAME eckit-dhcopy
                        NOINSTALL
                        SOURCES     dhcopy.cc
                        LIBS        eckit_option eckit )

ecbuild_add_executable( TARGET      syslog_server
                        OUTPUT_NAME eckit-syslog-server
                        NOINSTALL
                        SOURCES     syslog-server.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      syslog_client
                        OUTPUT_NAME eckit-syslog-client
                        NOINSTALL
                        SOURCES     syslog-client.cc
                        LIBS        eckit )

ecbuild_add_executable( TARGET      eckit_hash
                        OUTPUT_NAME eckit-hash
                        NOINSTALL
                        SOURCES     eckit-hash.cc
                        LIBS        eckit_option eckit )

=== tests/io/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
t.grib
)

if(HAVE_EXTRA_TESTS)
    ecbuild_get_test_multidata( TARGET get_eckit_io_test_data
                                NAMES ${test_data_files}
                                NOCHECK )
endif()

ecbuild_add_test( TARGET  eckit_test_easycurl
                  SOURCES test_easycurl.cc
                  CONDITION HAVE_EXTRA_TESTS AND eckit_HAVE_CURL
                  LIBS    eckit )

file(
  COPY mock/MockREST.py mock/MockREST.launcher.sh
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
)

ecbuild_add_test( TARGET  eckit_test_urlhandle
                  SOURCES test_urlhandle.cc
                  CONDITION HAVE_EXTRA_TESTS AND eckit_HAVE_CURL
                  LIBS    eckit )

foreach(_test
        base64
        bitio
        buffer
        bufferlist
        circularbuffer
        compress
        filelock
        filepool
        multihandle
        partfilehandle
        pooledfile
        pooledhandle )
  ecbuild_add_test( TARGET  eckit_test_${_test}
                    SOURCES test_${_test}.cc
                    LIBS    eckit )
endforeach()

ecbuild_add_test( TARGET      eckit_test_radoshandle
                  SOURCES     test_radoshandle.cc
                  CONDITION   HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_rados-performance
                  SOURCES     rados-performance.cc
                  CONDITION   HAVE_EXTRA_TESTS AND HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  TEST_DEPENDS get_eckit_io_test_data
                  LIBS        eckit )

=== tests/linalg/CMakeLists.txt ===
# (C) Copyright 1996- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation
# nor does it submit to any jurisdiction.

ecbuild_add_test( TARGET    eckit_test_linalg_factory
                  ARGS      --log_level=message
                  SOURCES   test_la_factory.cc
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg_dense.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg_sparse.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_matrix
                  ARGS      --log_level=message
                  SOURCES   test_la_matrix.cc
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_tensor
                  ARGS      --log_level=message
                  SOURCES   test_la_tensor.cc util.h
                  LIBS      eckit_linalg )

# LinearAlgebra
ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend
                  ARGS      --log_level=message
                  SOURCES   test_la_linalg.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_generic
                  COMMAND   eckit_test_linalg_mixed_backend
                  ARGS      --log_level=message -linearAlgebraBackend generic )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_cuda
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_eigen
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_lapack
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_LAPACK
                  ARGS      --log_level=message -linearAlgebraBackend lapack )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_mkl
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_mixed_backend_openmp
                  COMMAND   eckit_test_linalg_mixed_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraBackend openmp )

# LinearAlgebraDense

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_generic
                  COMMAND   eckit_test_linalg_dense_backend
                  ARGS      --log_level=message -linearAlgebraDenseBackend generic )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_cuda
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraDenseBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_eigen
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraDenseBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_lapack
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_LAPACK
                  ARGS      --log_level=message -linearAlgebraDenseBackend lapack )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_mkl
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraDenseBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_dense_backend_openmp
                  COMMAND   eckit_test_linalg_dense_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraDenseBackend openmp )

# LinearAlgebraSparse

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_generic
                  COMMAND   eckit_test_linalg_sparse_backend
                  ARGS      --log_level=message -linearAlgebraSparseBackend generic )

# This test seems to have a system call exit with 1 even though tests pass.
# Ignore system errors, see also http://stackoverflow.com/a/20360334/396967
ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_cuda
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_CUDA
                  ARGS      --log_level=message -linearAlgebraSparseBackend cuda --catch_system_errors=no )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_hip
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_HIP
                  ARGS      --log_level=message -linearAlgebraSparseBackend hip )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_eigen
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_EIGEN
                  ARGS      --log_level=message -linearAlgebraSparseBackend eigen )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_mkl
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_MKL
                  ARGS      --log_level=message -linearAlgebraSparseBackend mkl )

ecbuild_add_test( TARGET    eckit_test_linalg_sparse_backend_openmp
                  COMMAND   eckit_test_linalg_sparse_backend
                  CONDITION eckit_HAVE_OMP
                  ARGS      --log_level=message -linearAlgebraSparseBackend openmp )

#

ecbuild_add_test( TARGET    eckit_test_linalg_sparse
                  ARGS      --log_level=message
                  SOURCES   test_la_sparse.cc util.h
                  LIBS      eckit_linalg )

ecbuild_add_test( TARGET    eckit_test_linalg_streaming
                  ARGS      --log_level=message
                  SOURCES   test_la_streaming.cc util.h
                  LIBS      eckit_linalg )

=== tests/memory/CMakeLists.txt ===
option( ENABLE_ECKIT-351 "Control if ECKIT-351 tests should be enabled" ON )

ecbuild_add_test( TARGET      eckit_test_memory_counted
                  SOURCES     test_counted.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_factory
                  SOURCES     test_factory.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_memory_mmap
                  SOURCES     test_memory_mmap.cc
                  LIBS        eckit
                  CONDITION   ENABLE_ECKIT-351 )

=== tests/utils/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
2t_sfc.grib
2t_sfc_regrid.grib
vo-d_6ml.grib
u-v_6ml.grib
q_6ml_regrid.grib
)

if(HAVE_EXTRA_TESTS)
        ecbuild_get_test_multidata( TARGET get_eckit_test_data
                                    NAMES ${test_data_files}
                                    NOCHECK )
endif()

ecbuild_add_test( TARGET      eckit_test_utils_byteswap
                  SOURCES     test_byteswap.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_string_tools
                  SOURCES     test_string_tools.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_translator
                  SOURCES     test_translator.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_tokenizer
                  SOURCES     test_tokenizer.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_semanticversion
                  SOURCES     test_semanticversion.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_rendezvoushash
                  SOURCES     test_rendezvoushash.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_rle
                  SOURCES     test_rle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compressor
                  SOURCES     test_compressor.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hashing
                  CONDITION   eckit_HAVE_SSL
                  INCLUDES    "${OPENSSL_INCLUDE_DIR}"
                  SOURCES     test_hashing.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_hash_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  SOURCES     hash-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_utils_compression_performance
                  CONDITION   HAVE_EXTRA_TESTS
                  TEST_DEPENDS get_eckit_test_data
                  SOURCES     compression-performance.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_regex
                  SOURCES     test_regex.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_literals
                  SOURCES     test_literals.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_safe_casts
                  SOURCES     test_safe_casts.cc
                  LIBS        eckit )

=== src/eckit/linalg/CMakeLists.txt ===
unset( eckit_la_pincludes )
unset( eckit_la_plibs )
list( APPEND eckit_la_srcs
      BackendRegistry.h
      LinearAlgebra.cc
      LinearAlgebra.h
      LinearAlgebraDense.cc
      LinearAlgebraDense.h
      LinearAlgebraSparse.cc
      LinearAlgebraSparse.h
      Matrix.cc
      Matrix.h
      SparseMatrix.cc
      SparseMatrix.h
      Tensor.cc
      Tensor.h
      Triplet.cc
      Triplet.h
      Vector.cc
      Vector.h
      allocator/BufferAllocator.cc
      allocator/BufferAllocator.h
      allocator/NonOwningAllocator.cc
      allocator/NonOwningAllocator.h
      allocator/StandardAllocator.cc
      allocator/StandardAllocator.h
      allocator/StandardContainerAllocator.cc
      allocator/StandardContainerAllocator.h
      dense/LinearAlgebraGeneric.cc
      dense/LinearAlgebraGeneric.h
      sparse/LinearAlgebraGeneric.cc
      sparse/LinearAlgebraGeneric.h
      types.h )

if( eckit_HAVE_CUDA )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraCUDA.cc
          dense/LinearAlgebraCUDA.h
          detail/CUDA.h
          sparse/LinearAlgebraCUDA.cc
          sparse/LinearAlgebraCUDA.h )
    list( APPEND eckit_la_plibs CUDA::cudart CUDA::cusparse CUDA::cublas )
endif()

if( eckit_HAVE_HIP )
    list( APPEND eckit_la_srcs
          sparse/LinearAlgebraHIP.cc
          sparse/LinearAlgebraHIP.h )
    list( APPEND eckit_la_plibs hip::host roc::hipsparse )
endif()


if( eckit_HAVE_EIGEN )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraEigen.cc
          dense/LinearAlgebraEigen.h
          sparse/LinearAlgebraEigen.cc
          sparse/LinearAlgebraEigen.h )
endif()

if( eckit_HAVE_LAPACK )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraLAPACK.cc
          dense/LinearAlgebraLAPACK.h )
    list( APPEND eckit_la_plibs "${LAPACK_LIBRARIES}" )
endif()

if( eckit_HAVE_MKL )
    list( APPEND eckit_la_srcs
          dense/LinearAlgebraMKL.cc
          dense/LinearAlgebraMKL.h
          sparse/LinearAlgebraMKL.cc
          sparse/LinearAlgebraMKL.h )
    list( APPEND eckit_la_pincludes "${MKL_INCLUDE_DIRS}" )
    list( APPEND eckit_la_plibs "${MKL_LIBRARIES}" )
endif()

if( eckit_HAVE_OMP )
    list( APPEND eckit_la_plibs OpenMP::OpenMP_CXX )
endif()

ecbuild_add_library( TARGET             eckit_linalg TYPE SHARED
                     INSTALL_HEADERS    ALL
                     HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/eckit/linalg
                     SOURCES            ${eckit_la_srcs}
                     PRIVATE_INCLUDES   ${eckit_la_pincludes}
                     PUBLIC_LIBS        eckit
                     PRIVATE_LIBS       ${eckit_la_plibs} )

if( eckit_HAVE_EIGEN )
    if(NOT EIGEN3_INCLUDE_DIRS AND TARGET Eigen3::Eigen)
        get_target_property(EIGEN3_INCLUDE_DIRS Eigen3::Eigen INTERFACE_INCLUDE_DIRECTORIES)
    endif()

    # Add include directories with "SYSTEM" to avoid warnings from within Eigen headers
    target_include_directories( eckit_linalg SYSTEM PRIVATE ${EIGEN3_INCLUDE_DIRS} )
endif()

=== src/eckit/sql/CMakeLists.txt ===
list( APPEND eckit_sql_lib_srcs
    Environment.cc
    Environment.h
    SQLBitColumn.cc
    SQLBitColumn.h
    SQLColumn.cc
    SQLColumn.h
    SQLDatabase.cc
    SQLDatabase.h
    SQLDistinctOutput.cc
    SQLDistinctOutput.h
    SQLOrderOutput.cc
    SQLOrderOutput.h
    SQLOutput.cc
    SQLOutput.h
    SQLOutputConfig.cc
    SQLOutputConfig.h
    SQLParser.cc
    SQLParser.h
    SQLSelect.cc
    SQLSelect.h
    SQLSelectFactory.cc
    SQLSelectFactory.h
    SQLSession.cc
    SQLSession.h
    SQLSimpleOutput.cc
    SQLSimpleOutput.h
    SQLStatement.cc
    SQLStatement.h
    SQLTable.cc
    SQLTable.h
    SQLTableFactory.cc
    SQLTableFactory.h
    SQLTypedefs.h
    SchemaAnalyzer.cc
    SchemaAnalyzer.h
    SchemaComponents.cc
    SchemaComponents.h
    SelectOneTable.cc
    SelectOneTable.h
    expression/BitColumnExpression.cc
    expression/BitColumnExpression.h
    expression/ColumnExpression.cc
    expression/ColumnExpression.h
    expression/ConstantExpression.cc
    expression/ConstantExpression.h
    expression/NumberExpression.cc
    expression/NumberExpression.h
    expression/OrderByExpressions.cc
    expression/OrderByExpressions.h
    expression/ParameterExpression.cc
    expression/ParameterExpression.h
    expression/SQLExpression.cc
    expression/SQLExpression.h
    expression/SQLExpressionEvaluated.cc
    expression/SQLExpressionEvaluated.h
    expression/SQLExpressions.cc
    expression/SQLExpressions.h
    expression/ShiftedColumnExpression.cc
    expression/ShiftedColumnExpression.h
    expression/StringExpression.cc
    expression/StringExpression.h
    expression/function/DoubleFunctions.cc
    expression/function/FunctionAND.cc
    expression/function/FunctionAND.h
    expression/function/FunctionAVG.cc
    expression/function/FunctionAVG.h
    expression/function/FunctionCOUNT.cc
    expression/function/FunctionCOUNT.h
    expression/function/FunctionDOTP.cc
    expression/function/FunctionDOTP.h
    expression/function/FunctionEQ.cc
    expression/function/FunctionEQ.h
    expression/function/FunctionExpression.cc
    expression/function/FunctionExpression.h
    expression/function/FunctionFIRST.cc
    expression/function/FunctionFIRST.h
    expression/function/FunctionFactory.cc
    expression/function/FunctionFactory.h
    expression/function/FunctionIN.cc
    expression/function/FunctionIN.h
    expression/function/FunctionIntegerExpression.cc
    expression/function/FunctionIntegerExpression.h
    expression/function/FunctionJOIN.cc
    expression/function/FunctionJOIN.h
    expression/function/FunctionJULIAN.cc
    expression/function/FunctionJULIAN.h
    expression/function/FunctionJULIAN_SECONDS.cc
    expression/function/FunctionJULIAN_SECONDS.h
    expression/function/FunctionLAST.cc
    expression/function/FunctionLAST.h
    expression/function/FunctionMAX.cc
    expression/function/FunctionMAX.h
    expression/function/FunctionMIN.cc
    expression/function/FunctionMIN.h
    expression/function/FunctionNE.cc
    expression/function/FunctionNE.h
    expression/function/FunctionNORM.cc
    expression/function/FunctionNORM.h
    expression/function/FunctionNOT_IN.cc
    expression/function/FunctionNOT_IN.h
    expression/function/FunctionNOT_NULL.cc
    expression/function/FunctionNOT_NULL.h
    expression/function/FunctionNULL.cc
    expression/function/FunctionNULL.h
    expression/function/FunctionNVL.cc
    expression/function/FunctionNVL.h
    expression/function/FunctionOR.cc
    expression/function/FunctionOR.h
    expression/function/FunctionRLIKE.cc
    expression/function/FunctionRLIKE.h
    expression/function/FunctionRMS.cc
    expression/function/FunctionRMS.h
    expression/function/FunctionROWNUMBER.cc
    expression/function/FunctionROWNUMBER.h
    expression/function/FunctionSTDEV.cc
    expression/function/FunctionSTDEV.h
    expression/function/FunctionSUM.cc
    expression/function/FunctionSUM.h
    expression/function/FunctionTDIFF.cc
    expression/function/FunctionTDIFF.h
    expression/function/FunctionTHIN.cc
    expression/function/FunctionTHIN.h
    expression/function/FunctionTIMESTAMP.cc
    expression/function/FunctionTIMESTAMP.h
    expression/function/FunctionVAR.cc
    expression/function/FunctionVAR.h
    type/SQLBit.cc
    type/SQLBit.h
    type/SQLBitfield.cc
    type/SQLBitfield.h
    type/SQLDouble.cc
    type/SQLDouble.h
    type/SQLInt.cc
    type/SQLInt.h
    type/SQLReal.cc
    type/SQLReal.h
    type/SQLString.cc
    type/SQLString.h
    type/SQLType.cc
    type/SQLType.h
)

ecbuild_generate_yy(
    YYPREFIX eckit_sql_
    YACC sqly
    LEX sqll
    FLEX_FLAGS "-d"
    DEPENDANT SQLParser.cc
)

# Supress warnings emited from YACC/LEX generated code
if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    list(APPEND suppress_warnings
        -Wno-unused-function
    )
elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    list(APPEND suppress_warnings
        -Wno-unused-function
        -Wno-unused-but-set-variable
    )
endif()
set_source_files_properties(
    SQLParser.cc
    PROPERTIES
        COMPILE_OPTIONS "${suppress_warnings}"
)

ecbuild_add_library( TARGET              eckit_sql TYPE SHARED
                     INSTALL_HEADERS     ALL
                     HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/sql
                     SOURCES             ${eckit_sql_lib_srcs}
                     TEMPLATES
                                         SQLIteratorOutput.cc
                                         expression/ShiftedColumnExpression.cc
                     PUBLIC_LIBS         eckit )

# Disable all warnings for PGI/NVHPC compiler as it is overzealous and cherry-picking is not possible
target_compile_options( eckit_sql PRIVATE $<$<CXX_COMPILER_ID:PGI>:-w> $<$<CXX_COMPILER_ID:NVHPC>:-w> )

=== debian/changelog ===
eckit (2.0.1-2) unstable; urgency=medium

  * Disable HIP; missing on some archs

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 07:34:39 +0000

eckit (2.0.1-1) unstable; urgency=medium

  * New upstream release
  * Cleanup d/control with cme
  * Drop leading / in d/*install paths
  * Header for zip.patch
  * JEMALLOC support dropped in 2.0.0
  * Drop RSYNC dependencies; no longer used
  * Undo zip.patch; Debian now uses standard name

  * disable-cache-test.patch: Drop test that breaks compilation

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Feb 2026 09:30:52 +0000

=== debian/control ===
Source: eckit
Standards-Version: 4.7.3
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Alastair McKinstry <mckinstry@debian.org>,
Section: science
Build-Depends:
 debhelper-compat (= 13),
 architecture-is-64-bit,
 ecbuild,
 chrpath,
 flex,
 bison,
 libopenblas-dev [ !alpha !hurd-amd64 ],
 libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64 ],
 liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 libaec-dev,
 libxxhash-dev,
 librados-dev [ !loong64 ],
 libradospp-dev,
 libproj-dev,
 libbz2-dev,
 liblz4-dev,
 libshp-dev,
 libzip-dev,
 libeigen3-dev,
 libsnappy-dev,
 libqhull-dev,
 mpi-default-dev,
 doxygen,
 sphinx-common,
 python3-sphinx,
 python3-pydata-sphinx-theme,
 python3-breathe,
 python3-sphinxcontrib.jquery,
 python3-all,
 libssl-dev,
 libcurl4-gnutls-dev,
 libncurses-dev,
 libhipsparse-dev [amd64 arm64 ppc64el],
Vcs-Browser: https://salsa.debian.org/science-team/eckit
Vcs-Git: https://salsa.debian.org/science-team/eckit.git -b debian/latest
Homepage: https://github.com/ecmwf/eckit

Package: libeckit-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libeckit0d (= ${binary:Version}),
 libeckit-utils (= ${binary:Version}),
 mpi-default-dev,
 libaec-dev,
 libssl-dev,
 libcurl4-gnutls-dev,
 libxxhash-dev,
 libsnappy-dev,
 liblz4-dev,
 libbz2-dev,
 libeigen3-dev,
 libopenblas-dev [ amd64 arm64 mips64el ppc64el s390x ppc64],
 libblas-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 liblapack-dev [ !amd64 !arm64 !mips64el !ppc64el !s390x !ppc64],
 ${shlibs:Depends},
 ${misc:Depends},
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libeckit0d ( = ${binary:Version}),
 ${shlibs:Depends},
Recommends:
 libeckit-dev,
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

DO_TEST:=true

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

NO_RADOS_ARCH:= loong64
RADOS:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_RADOS_ARCH)),Off,On)

export HIPCC=clang++-21

# JEMALLOC Turned off as it breaks magics-python currently (TLS space)

BUILD_FLAGS = \ -DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DHAVE_TESTS=Off \
	-DENABLE_CONVEX_HULL=On \
	-DENABLE_SSL=On \
	-DENABLE_ECKIT_GEO=On \
	-DENABLE_GEO_CACHING=On \
	-DENABLE_PROJ=On \
	-DENABLE_RADOS=$(RADOS) \
	-DENABLE_OMP=On \
	-DENABLE_DOCS=Off \
	-DENABLE_HIP=Off

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_clean:
	rm -rf debian/build-*
	rm -rf docs/_build

override_dh_auto_configure:
	dh_auto_configure --  ${BUILD_FLAGS} 
	# Additional testdata.. Not used 
	# ( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	$(DO_TEST) && ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  ) || true

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*/*.so.0d
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%PROJ::proj;%%g'  $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*

=== debian/watch ===
# Avoid v5 for now; 200x.xx.xx tags get pulled
version=4
https://github.com/ecmwf/eckit/tags .*/v?(\d.*)@ARCHIVE_EXT@
